#pragma once

/**
*/
class CMsgList : private boost::noncopyable {
public:
    CMsgList();
    ~CMsgList();

    // Sč폜
    void Clear();
    // ǉĒǉCfbNXԂ
    int Add(int nPID, int nNum, const string& msg);
    // ʍ폜
    void Delete(int i);

    //@{ 擾
    int GetCount() const { return int(m_vctMsg.size()); }
    int GetPID(int i) const { return m_vctMsg[i].nPID; }
    int GetNum(int i) const { return m_vctMsg[i].nNum; }
    const string& GetMsg(int i) const { return m_vctMsg[i].strMsg; }
    //@}

    /// LȃCfbNXǂ
    bool IsValidIndex(int i) const { return 0 <= i && i < GetCount(); }

//private:
    struct SMsg {
        int nPID;
        int nNum;
        string strMsg;
        SMsg(int a, int b, const string& c) : nPID(a), nNum(b), strMsg(c) {}
    };
private:
    boost::ptr_vector<CMsgList::SMsg> m_vctMsg;
    auto_ptr<boost::mutex> mutex;
};

