#pragma once
#include "Archiver.h"
namespace Themis {

/**
    UnRar32.dllpďɃt@C߂̃NXB
*/
class CUnRarArchiver: public IArchiver {
public:
    CUnRarArchiver();
    ~CUnRarArchiver();

    void ConfigDialog(HWND hWnd);

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const { return eTypeNormal; }
};

typedef DefaultFactory<CUnRarArchiver, IArchiver>  CUnRarArchiverFactory;

}
