#pragma once
#include "Utility/Algorithm.h"
namespace Themis {

/**
 * `XV`̊Ǘ
 *
 * ŏIIȂS̋`݂͌ɏdȂ\邽߁A
 * `Ȃǂ܂ޕ`sꍇ͏ԂɋCׂB
 */
class CDirtyRect : private boost::noncopyable {
public:
    CDirtyRect() { Clear(); }
    ~CDirtyRect() {}

    /// `̑S
    void Clear() { m_nCount = 0; }

    /// `̒ǉ
    void Add(const CRect& rc) {
        int nMin = INT_MAX;
        int nMinPos = -1;
        CRect rcMin;
        for (int i = 0; i < lengthof(m_rc); i++) {
            CRect rcTmp = m_rc[i].GetUnion(rc);
            int n = rcTmp.GetSpace() - m_rc[i].GetSpace();
            if (n < nMin) {
                nMin = n;
                nMinPos = int(i);
                rcMin = rcTmp;
                if (n == 0) return; // ĂςȂȂ炻ŏI
            }
        }
        Themis_DebugAssert(nMinPos != -1);
        if (m_nCount < lengthof(m_rc) && rc.GetSpace() < nMin) {
            m_rc[m_nCount++] = rc;
        } else {
            m_rc[nMinPos] = rcMin;
        }
    }
    /// `ŜXV̈Ƃ
    void AddAll() {
        m_nCount = 1;
        m_rc[0] = CRect::GetMax();
    }

    /// ̋`ɊSɊ܂܂`O
    void RemoveUnion() {
        for (int i = 0; i < m_nCount - 1; i++) {
            for (int j = i + 1; j < m_nCount; ) {
                if (m_rc[i].IsIn(m_rc[j])) {
                    // m_rc[j] 菜
                    for (int k = j + 1; k < m_nCount; k++) {
                        m_rc[k - 1] = m_rc[k];
                    }
                    m_nCount--;
                } else {
                    j++;
                }
            }
        }
    }
    /// XV`Lǂ
    int GetCount() const { return m_nCount; }
    /// XV`̎擾
    const CRect& Get(int i) const { return m_rc[i]; }

private:
    CRect   m_rc[4];
    int     m_nCount;
};

}
