#pragma once
#include "Plane.h"
namespace Themis {

/**
    }XNȂǂɎg256Fv[B

    pbg肷͖̂ʓ|Ȃ̂ŁAmN̉摜}XNɗp邾Ƃ
*/
class CPlane8 : public CPlane {
public:
    CPlane8(const std::tr1::shared_ptr<IPlaneImpl>& pImpl) : CPlane(pImpl, 8) {}
    /// F̔]
    virtual void ReverseFill(CRect rcDst);
    /// sNZl̕z߂
    virtual void GetHistogram(int anHistogram[0x100], CRect rcSrc);
};

class CPlane32;

/**
    EffectorƂ₷悤ɁAFɈˑȂPlaneŁA`ƂFXo郂mB
*/
class CPlaneEx : public CPlane {
public:
    CPlaneEx(const std::tr1::shared_ptr<IPlaneImpl>& pImpl, int nBpp) : CPlane(pImpl, nBpp) {}

    /// F]
    virtual void ReverseFill(CRect rcDst) = 0;
    /// sxwhԂ(nAlpha:0x100ŕsEnAlpha:0x00œ)
    virtual void AlphaFill(COLORREF rgb, CRect rcDst, int nAlpha) = 0;
    /// OaZ
    virtual void SatAddFill(COLORREF rgb, CRect rcDst) = 0;
    /// OaZ
    virtual void SatSubFill(COLORREF rgb, CRect rcDst) = 0;
    //@{ UCN`
    virtual void MosaicFill(CRect rc, int nLevel) = 0;
    virtual void MosaicAverageFill(CRect rc, int nLevel) = 0;
    //@}
    /// 邳ƃRgXgB0ŁA-256`+256B}128x܂łɂƂׂB
    void BrightContrastFill(const CRect& rcDst, int nBright, int nContrast);
    /// K}␳(Photoshop݂̂Ȋ)
    void GammaRevFill(const CRect& rcDst, double dGamma);
    /// x␳(Photoshop݂̂Ȋ)
    void LevelRevFill(const CRect& rcDst, int nLow, int nHigh);
    /// x␳(e[u)
    virtual void LevelRevTableFill(CRect rcDst, uint8_t abyTable[0x100]) = 0;
    /// O[XP[(RGBϒl)
    virtual void GrayFill(CRect rc) = 0;
    /// O[XP[(Ȗ邳)
    virtual void GrayFillStrict(CRect rc) = 0;
    /// _Ot̍쐬
    virtual void MakeBargraph(CRect rcDst, double adData[], int nDataCount, double dDataMin, double dDataMax, COLORREF rgbBg) = 0;
    /// 邳(mol)̕z߂
    virtual void GetHistogram(int anHistogram[0x100], CRect rcSrc) = 0;
    /// 邳(RGBϒl)̕z߂
    virtual void GetHistogramRGBAverage(int anHistogram[0x100], CRect rcSrc) = 0;
    /// r, g, b ꂼ̕z߂
    virtual void GetHistogramRGB(int anHistogramR[0x100], int anHistogramG[0x100], int anHistogramB[0x100], CRect rcSrc) = 0;
    /// F擾(l͍lȂ)
    virtual int GetColorCount(CRect rc) = 0;
    /// w͈͂̕ϐF߂
    virtual COLORREF GetAverageColor(CRect rc) = 0;
    /// lO()ɁB
    virtual void ClearAlpha() = 0;
    /// l𔽓](sEs)
    virtual void ReverseAlpha() = 0;
    /// 邳lɁB(ÂƂ낪)
    virtual void BrightToAlpha() = 0;
    /// RGBϒll
    virtual void DiffToAlpha(const CPlane& rSrc) = 0;
    /// ̖邳l(x)
    virtual void DiffToAlphaStrict(const CPlane& rSrc) = 0;
    /// lĂ邩ǂKɔʂ(Əd)
    virtual bool HasAlphaChannel(CRect rcDst) = 0;

    /// Fu](832)
    virtual void TableBlt(const CPlane8& rSrc, CPoint ptDst, CRect rcSrc, COLORREF rgbTable[0x100], const CClipper& rClip = CClipper()) = 0;

    /// FtP]
    virtual void BltTrans(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, COLORREF rgbTrans, const CClipper& rClip = CClipper()) = 0;
    /// ڂ
    virtual void BefogBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// V[v
    virtual void SharpBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// V[v()
    virtual void HardSharpBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// KEXڂ
    virtual void GaussBefogBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double r, const CClipper& rClip = CClipper()) = 0;
    /// AV[v}XN
    virtual void UnsharpMaskBlt(const CPlane& rSrc, const CPlane& rMask, CPoint ptDst, CRect rcSrc, CPoint ptMask, const CClipper& rClip = CClipper()) = 0;
    /// fBAtB^
    virtual void MedianFilterBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// Eڂ
    virtual void BefogEdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper()) = 0;
    /// 񋫊Eڂ
    virtual void BefogNotEdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper()) = 0;
    /// Eo
    virtual void EdgeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dRate, const CClipper& rClip = CClipper()) = 0;

    /// `l~LT[ (RGB)
    virtual void ChannelMixerBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double rr, double rg, double rb, double gr, double gg, double gb, double br, double bg, double bb, const CClipper& rClip = CClipper()) = 0;
    /// `l~LT[ (O[XP[)
    virtual void ChannelMixerBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double kr, double kg, double kb, const CClipper& rClip = CClipper()) = 0;

    /// _a]
    virtual void OrBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// _ϓ]
    virtual void AndBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// rI_a]
    virtual void XorBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// OaZ]
    virtual void SatAddBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// OaZ]
    virtual void SatSubBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;

    /// xw](0x00ŕʁA0x100Ő^)
    virtual void FadeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nFade, const CClipper& rClip = CClipper()) = 0;
    /// Pxw](0x00ŕʁA0x100Ő^)
    virtual void BrightBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nBright, const CClipper& rClip = CClipper()) = 0;
    /// xw](0x00œA0x100ŕs)
    virtual void AlphaBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, int nAlpha, const CClipper& rClip = CClipper()) = 0;
    /// ]Qœxw](Src0x00œA0x100ŕsBSrc2͂̋t)
    virtual void BlendBlt(const CPlane& rSrc, const CPlane& rSrc2, CPoint ptDst, CRect rcSrc, int nAlpha, const CClipper& rClip = CClipper()) = 0;

    /// Wrbg}XNp^[p](nLow <= }XNl <= nHigh̓_])
    virtual void MaskBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nLow, int nHigh, const CClipper& rClip = CClipper()) = 0;
    /// Wrbg}XNp^[p](nBorder <= }XNl <= nBorder+nVague̓_AFade:0x000x100܂ŒiKIɕ`B͈͊Oꂼ0x000x100)
    virtual void MaskFadeBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper()) = 0;
    /// Wrbg}XNp^[p](nBorder <= }XNl <= nBorder+nVague̓_ABright:0x000x100܂ŒiKIɕ`B͈͊Oꂼ0x000x100)
    virtual void MaskBrightBlt(const CPlane& rSrc, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper()) = 0;
    /// Wrbg}XNp^[p]
    virtual void MaskBlendBlt(const CPlane& rSrc, const CPlane& rSrc2, const CPlane8& rMask, CPoint ptDst, CRect rcSrc, int nBorder, int nVague, const CClipper& rClip = CClipper()) = 0;

    /// ]̃ll]
    virtual void BltAlpha(const CPlane32& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;

    //@{ k](jAXglCo[AoCjAAʐϕϖ@HALanczos3B`Alpha̓lΉ)
    virtual void StretchBltNearest(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBlt(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBltAlpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBltPixelAveration(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBltPixelAverationAlpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBltLanczos3(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    virtual void StretchBltLanczos3Alpha(const CPlane& rSrc, CRect rcDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    //@}

    /// ClearTypeit̔zɍ킹ĐF炷jsB̉͗~TCŶR{ɂׂB
    virtual void ClearTypeBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;

    /// E]]
    virtual void MirrorHBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// ㉺]]
    virtual void MirrorVBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// 180x]]
    virtual void Rot180Blt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// v90x]]
    virtual void Rot90ClockwiseBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// v90x]]
    virtual void Rot90AntiClockwiseBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper()) = 0;
    /// pxw]](dAngle͌ʓx@ł͂ȂA360łP]̕ArgbFill͉摜̖sNZhԂF)
    virtual void RotBlt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dAngle, COLORREF rgbFill, const CClipper& rClip = CClipper()) = 0;
    /// pxw]]A掿ߔ
    virtual void RotBltDraft(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, double dAngle, COLORREF rgbFill, const CClipper& rClip = CClipper()) = 0;

    /// 邳ƃRgXgȃe[u쐬
    static void MakeBrightContrastTable(uint8_t abyTable[0x100], int nBright, int nContrast);
    /// K}␳̃e[u쐬
    static void MakeGammaRevTable(uint8_t abyTable[0x100], double dGamma);
    /// x␳̃e[u쐬
    static void MakeLevelRevTable(uint8_t abyTable[0x100], int nLow, int nHigh);
    /// ClearTypeBlt̓]TCYZo
    static CSize GetClearTypeSize(const CSize& sz) { return CSize(sz.cx * 3, sz.cy); }
    /// pxw]]̓]KvTCY̎Zo
    static CSize GetRotSize(const CSize& szSrc, double dAngle);
    /// 90x]̃TCYZoict]j
    static CSize GetRot90Size(const CSize& szSrc) { return CSize(szSrc.cy, szSrc.cx); }
};

}
