#pragma once
#include "../../ObjectPool.h"
#include "../GDI/Dib.h"
#include "MemoryPlane.h"
namespace Themis {

/**
    v[IuWFNg̐sC^[tF[X

    ev[gg킸CPlaneExŒ肾CPlane32L̂Ƃgꍇ
    sւȂǁA[Ƃdynamic_castƂŁB
*/
class CPlaneFactory : private boost::noncopyable {
public:
    virtual ~CPlaneFactory() {}
    /// v[̍쐬
    virtual std::tr1::shared_ptr<CPlaneEx> CreateInstance() = 0;
    /// gpĂȂLbV̍폜
    virtual void Garbage() {}
    /// LbV̎擾
    virtual int GetCount() const { return 0; }
    /// v[ĂIuWFNgȂtrue
    virtual bool IsEmpty() const { return true; }
    /// őv[̐ݒ
    virtual void SetMaxPoolCount(int n) {}
};

/**
    v[IuWFNg̍쐬sB

    SmartPtr̎QƃJEgȂCX^X
    PlaneFactoryɕԋpAȍ~CreateInstance()ōėpB

    AppWindowȂǂCPlaneFactory??<???>A
    qIuWFNgPlane̐sƂ͕KCPlaneFactory??&󂯎ĎgƂɂ΁A
    qIuWFNgPlane̎Ɛ؂藣ACӂ̎_Ńv[̐\ƂȂB

    ėpFactorył͂Ȃʂɗpӂ闝RƂẮA
    GDIDirectDraw̐؂ւ\ɂׂƁA
    DIBDirectSurface̕pɂȐÊׁB
*/
template<class CPlane> class CPlaneFactoryT : public CPlaneFactory {
    ObjectPool<CPlane> pool;
public:
    CPlaneFactoryT() {
        pool.SetMaxPoolCount(4);
    }
    ~CPlaneFactoryT() {
    }

    /// v[IuWFNg̍쐬
    std::tr1::shared_ptr<CPlaneEx> CreateInstance() {
        return pool.CreateInstance();
    }

    /// gpĂȂIuWFNg̍폜
    void Garbage() {
        pool.Garbage();
    }

    /// v[ĂIuWFNǧ̎擾
    int GetCount() const { return static_cast<int>(pool.GetCount()); }
    /// v[ĂIuWFNgȂtrue
    bool IsEmpty() const { return pool.IsEmpty(); }
    /// őv[̐ݒ
    void SetMaxPoolCount(int n) { pool.SetMaxPoolCount(n); }
};

class CPlaneFactory32 : public CPlaneFactoryT<CMemoryPlane32> {};
class CDibPlaneFactory32 : public CPlaneFactoryT<CDib32> {};

}
