#pragma once
namespace Themis {

class CHotKey;

/**
    L[RtBO邽߂̕⏕NXB

    HotKeyIDWM_COMMANDIDƕ\ZbgŎA
    j[o[̍XVAWM_COMMAND̑MA\̗(o^)A
    \HotKeyId̎擾AHotKeyId\̎擾sB
*/
class CKeyConfig : private boost::noncopyable {
public:
    CKeyConfig();
    ~CKeyConfig();

    /// f[^SĔj
    void Clear();
    /// f[^̓o^
    void Add(int nHotKeyId, const string& viewName, int nCommand);
    /// f[^̌ʓo^j(d)
    void Remove(int nHotKeyId);

    /// j[o[Ɂu얼[tab]V[gJbgL[vݒ肷
    void UpdateMenubar(HMENU hMenu, CHotKey& rHotKey) const;

    /// j[Lȏꍇ̂SendCommand()Bʂ͂gׂ
    void SendCommandOnEnable(HWND hWnd, HMENU hMenu, int nHotKeyId) const;
    /// nHotKeyIdɑΉWM_COMMANDEBhEɑM
    void SendCommand(HWND hWnd, int nHotKeyId) const;

    /// 擾
    int GetCount() const { return static_cast<int>(m_vctData.size()); }
    /// iԖڂ̕\擾(o^)
    const string&  GetViewName(int i) const { return m_vctData[i].viewName; }

    /// \HotKeyId̎擾AȂ-1B
    int GetIdFromViewName(const string& strViewName) const;
    /// nHotKeyId\̎擾AȂ΋󕶎B
    const string& GetViewNameFromId(int nHotKeyId) const;

protected:
    /// iԖڂCOMMANDID擾(o^)
    int GetCommandId(int i) const { return m_vctData[i].nCommand; }

private:
    struct SData {
        string viewName;
        int nCommand;
    };
    vector<SData>           m_vctData;
    std::map<int, int>      m_oId2Index;    // HotKeyIdɑΉm_vctDatȁ
};

}
