#include "stdafx.h"
#include "Rand.h"
#include "Windows/SystemRand.h"
namespace Themis {

CRand& CRand::GetInstance() {
    static CRand s_oRand;
    return s_oRand;
}

namespace {
    unsigned MakeSeed() {
        boost::optional<unsigned> nRand = SystemRand::GetSafe();
        if (nRand) return *nRand;
        // dȂ̂œK
        POINT c;
        ::GetCursorPos(&c);
        DWORD p = ::GetCurrentProcessId();
        DWORD k = ::GetTickCount();
        c.x ^= c.x << 10;
        c.y ^= c.y << 20;
        p ^= p << 15;
        k ^= k << 20;
        return c.x ^ c.y ^ p ^ k;
    }
    unsigned MakeSeed2() {
     // boost::optional<unsigned> nRand = SystemRand::GetSafe();
     // if (nRand) return *nRand;
        // dȂ̂œK̂Q
        DWORD t = ::GetCurrentThreadId();
        t ^= t << 25;
        LARGE_INTEGER l;
        if (::QueryPerformanceCounter(&l) != FALSE) {
            l.LowPart ^= l.LowPart << 10;
            l.HighPart ^= l.HighPart << 15;
            return l.LowPart ^ l.HighPart ^ t;
        }
        return t;
    }
}
void CRand::Randomize() {
    SetSeed(MakeSeed());
}

void CRand::RandomizeCarefully() {
    unsigned seeds[std::tr1::mt19937::state_size];
    bool success = true;
    DWORD tick = ::GetTickCount();
    {
        SystemRand& rnd = SystemRand::GetInstance();
        if (!rnd.GenRandom(seeds, sizeof(seeds))) {
            // s͓KɁB
            success = false;
            ::Sleep(0);
            seeds[0] = MakeSeed() ^ MakeSeed2();
            seeds[0] ^= (::GetTickCount() - tick);
        }
    }
    if (success) {
        SetSeed(seeds);
    } else {
        SetSeed(seeds[0]);
    }
}

}
