#pragma once
#include "Archiver.h"
namespace Themis {

/**
    UnGca32.dllpďɃt@C߂̃NXB
*/
class CUnGcaArchiver: public IArchiver {
public:
    CUnGcaArchiver();
    ~CUnGcaArchiver();

    void ConfigDialog(HWND hWnd);

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractAll(const CFileName& oDirName, bool showProgress);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const;
    bool solid;
};

typedef DefaultFactory<CUnGcaArchiver, IArchiver>  CUnGcaArchiverFactory;

}
