#pragma once
namespace Themis {

/**
    R}hC̉͗pNXB
*/
class CCommandLine : private boost::noncopyable {
public:
    CCommandLine(int argc, char* argv[]);
    CCommandLine(int argc, wchar_t* argv[]);
    CCommandLine(LPCSTR pszCmdLine);
    CCommandLine(LPCWSTR pszCmdLine);
    ~CCommandLine();

    //@{ ̒ڎ擾
    int GetCount() const { return static_cast<int>(m_vctCommand.size()); }
    const string& Get(int i) const { return m_vctCommand[i]; }
    const string& Get(int i, const string& def) const { return i < GetCount() ? Get(i) : def; }
    //@}

    //@{ vĂtrue
    bool IsMatch(int i, const string& str) { return Get(i) == str; }
    bool IsMatch(int i, const string& str, int nLen) { 
        return string::Compare(Get(i), 0, str, 0, nLen, StringComparison::CurrentCulture) == 0;
    }
    //@}

    /// Pڂ L'/'  L'-' Ȃtrue
    bool IsOption(int i) { return Get(i)[0] == L'/' || Get(i)[0] == L'-'; }
    /// QڂĕԂ
    wchar_t GetOptionLc(int i) { return Char::ToLower(Get(i)[1]); }

    /// t@CƂĎ擾i݂tH_ȏꍇI[\\ǉj
    CFileName GetFileName(int i, const CFileName& oBaseDir = CFileNameSystemDir()) const;
    /// SĂ̈t@CƌȂĂ܂Ƃ߂ĕԂ
    vector<CFileName> GetFileNames(const CFileName& oBaseDir = CFileNameSystemDir()) const;

private:
    List<string> m_vctCommand;
};

}
