#pragma once
#include "Fint.h"
namespace Themis {

/**
    FPS̒EFCgFPSl̎ZoNXB
*/
class CFpsTimer : private boost::noncopyable {
public:
    CFpsTimer(int nFps = 60, int nMaxSkipFrame = 15);
    ~CFpsTimer();

    /** ڕWFPSlݒB
        @param  nFps            ڕWFPSlB
        @param  nMaxSkipFrame   őAt[XLbv񐔁B0ȉȂXLbvB */
    void SetFps(int nFps, int nMaxSkipFrame);
    /// FPSvZt[XLbvJEgȂǂ܂ȏԂ
    void Reset();

    /// t[ɌĂяo
    void WaitFrame();

    /// `XLbvׂǂ(WaitFraměɌĂԂׂ)
    bool IsSkipDrawing() const { return (0 < m_nSkipCount); }

    /// ݂FPSl擾
    int GetNowFps() const { return m_nNowFps; }

private:
    fint        m_fFrameTime;       // Pt[ӂ̎ԁ((1000) / FPS) [ms]
    fint        m_fLastTime;        // OWaitFrame̎[ms]
    int         m_nSkipCount;       // t[XLbvĂ鐔
    int         m_nMaxSkip;         // XLbvt[̍ő吔
    unsigned    m_nLastCulcTime;    // ŌFPSvZ
    int         m_nFrameCount;      // FPSvZpɃt[JEgiO`PUj
    int         m_nNowFps;          // ݂FPS
};

}
