#pragma once
#include "Image.h"
namespace Themis {

/**
    OLEg摜t@C̓ǂݍ݃NX
*/
class COleLoader: public IImageLoader {
public:
    COleLoader();
    ~COleLoader();

    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const { return false; }
    string GetTypeName() const;
    string GetTypeFileName() const { return L"*.bmp;*.ico;*.jpg;*.jpeg;*.jpe;*.png;*.gif"; } //jpgƂgif͂ǁ[񂩁BB

private:
    void*       m_pPicture;   //IPicture*
};

/// OLEȉ摜ǂݍ݃NXFactory
typedef DefaultFactory<COleLoader, IImageLoader>   COleLoaderFactory;

}
