#pragma once
#include "MsgHook.h"
namespace Themis {

class CWindow;
class CLocalExclusion;

/**
    tXN[EEBhE[h̐؂ւsB

    fobO̓CEBhETOPMOSTȂdlƂ
    ӁF
        EtXN[̃j[o[̕ύX͋֎~B
        ESetSize()ASetBpp()ȂǂYꂸɌĂяoĂƁB

    WM_CLOSECWindow::Close()Oɂ폜قX[YɏICB
*/
class CScreenChanger: private IMsgHooker {
public:
    CScreenChanger(CWindow& rWindow);
    ~CScreenChanger();

    /// tXN[ɃJ[\Bǂݒ
    void SetHideCursor(bool b);
    /// tXN[ɃJ[\Bǂ擾
    bool IsHideCursor() const { return m_bHideCursor; }

    /// ANeBuɍŏ̂EBhE[hɖ߂邾Ȃ̂B
    void SetMinimizeOnDeactivate(bool m) { minOnDeactive = m; }
    /// ANeBuɍŏ̂EBhE[hɖ߂邾Ȃ̂B
    bool IsMinimizeOnDeactivate() const { return minOnDeactive; }

    /// Window[hɍőOʕ\̂ǂ
    void SetTopMost(bool b);
    /// Window[hɍőOʕ\Ȃtrue
    bool IsTopMost() const;

    //@{ XN[TCY̐ݒ
    CSize GetSize() const { return m_szScreen; }
    void SetSize(const CSize& sz) { m_szScreen = sz; }
    void SetSizeWindow();
    void SetSizeScreen();
    //@}

    //@{ F[x̐ݒ
    int GetBpp() const { return m_nBpp; }
    void SetBpp(int nBpp) { m_nBpp = nBpp; }
    void SetDefaultBpp() { m_nBpp = -1; }
    //@}

    //@{ j[o[̎擾Ɛݒƍĕ`
    HMENU GetMenu() const;
    void SetMenu(HMENU hMenu);
    void SetMenu(int nMenu);
    void UnsetMenu() { SetMenu(static_cast<HMENU>(NULL)); }
    void DeleteMenu();
    void DrawMenubar();
    //@}

    /// tXN[Ƒ[hƐ؂ւ
    void ChangeMode();
    /// tXN[
    void ToFullScreen();
    /// [h
    void ToWindowMode();

    /// ݃tXN[Ȃ̂
    bool IsFullScreen() const { return eStateFullScreen <= m_eState; }

    /// j[o[\
    void ShowMenubar();
    /// j[o[B
    void HideMenubar();

private:
    bool IsReadyMenubar();
    void ChangeWindowState();
    void RestoreWindowState();
    void ChangeDisplay();
    void Delete();
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    CWindow&                m_rWindow;
    auto_ptr<CWindow>       m_pMenubar;
    auto_ptr<CLocalExclusion>   m_pExclusion;
    CSize                   m_szScreen;
    int                     m_nBpp;

    int                     m_nStateOld;
    CRect                   m_rcOld;
    DWORD                   m_dwStyleOld;
    DWORD                   m_dwExStyleOld;
 // HWND                    m_hwndParentOld;

    enum EState {
        eStateWindowMode = 0,
        eStateFullScreen = 1,
        eStateTempWindowMode = 2,
    }                       m_eState;
    bool                    m_bHideCursor;
    bool                    m_bShowMenu;

    bool                    minOnDeactive;

    bool                    m_bDeleted;
};

}
