#pragma once
#include "../Rand.h"
namespace Themis {

class CDll;

/**
    ^̎ƂɎgAVXe̗B
*/
class SystemRand : public IRand<SystemRand> {
    auto_ptr<CDll> pDll;
    void* hProv;

    SystemRand();

public:
    ~SystemRand();

    static SystemRand& GetInstance();

    static boost::optional<unsigned> GetSafe() {
        try {
            return GetInstance().GenRandom();
        } catch (...) {
        }
        return boost::optional<unsigned>();
    }

    bool GenRandom(void* p, size_t n);
    boost::optional<unsigned> GenRandom();

    unsigned Get() {
        boost::optional<unsigned> t = GenRandom();
        if (!t) throw RuntimeException(L"VXe̎擾Ɏs܂");
        return *t;
    }
    unsigned GetMax() const { return UINT_MAX; }
};

}
