#pragma once
namespace Themis {

/**
    smart_ptrvectorB
*/
template<class _Tp> class smart_ptr_vector : public vector<std::tr1::shared_ptr<_Tp> > {
    typedef vector<std::tr1::shared_ptr<_Tp> > base_t;
public:
    smart_ptr_vector() {}
    template<class A> smart_ptr_vector(const A& a) : base_t(a) {}
    template<class A, class B> smart_ptr_vector(const A& a, const B& b) : base_t(a, b) {}
    template<class A, class B, class C> smart_ptr_vector(const A& a, const B& b, const C& c) : base_t(a, b, c) {}
};

}
